/* Sega G-80 System Vector Graphics Viewer  */
/* Date: 04-22-97                           */
/* Last update: 04-22-97                    */
/* Programmer: Clayton N. Cowgill           */
/* Requires: PC, VGA, 512K RAM, Microsoft   */
/*           Compatible Mouse, BGI drivers. */

#include <c:\tc\include\graphics.h>
#include <c:\tc\include\stdio.h>
#include <c:\tc\include\conio.h>
#include <c:\tc\include\process.h>
#include <c:\tc\include\dos.h>
#include <c:\tc\include\dir.h>
#include <c:\tc\include\alloc.h>
#include <c:\tc\include\math.h>
#include "c:\spredit\mousey.c"

#define CHARS 64
#define VRAM  4096

   unsigned cursor1[32] = {
	0xfff7,0xffe3,0xffc1,0xff80,0xff01,0xfe03,0xfc07,0xf80f,
	0xf01f,0xe03f,0xc07f,0x80ff,0x1ff,0x3ff,0x7ff,0xfff,
	0x0,0x8,0x1c,0x2e,0x44,0x98,0x130,0x260,
	0x4c0,0x980,0x1300,0x2600,0x5c00,0x6800,0x7000,0x0};
   unsigned hsx1 = 1;
   unsigned hsy1 = 14;

	unsigned char sprites[CHARS+1][8][8];

	unsigned size;
	int g_driver, g_mode, g_error, currentmode;
	int sprite=0;
   resetRec *z;
   locRec *rodent;
   char message[80];
	unsigned char vectorlist[VRAM];
	int address;
	float zoom;


int huge detect256(void);
void debounce();
void directory();
void install_vga();
void resume_graphics();
void draw_box();
void plot();
void save_screen();
void load_shape();
void save_font();
void init_mouse();
void dir(void);
void labels();
void skip();
void skip_back();

main()
{
	int event, x, y, b;
	int paint=1,key;
	int left=270,right=310,top=-8;
	int i,j,c; /* for character read and display routine */
	int new_tile=0;
	int quit_key;

	for (x=0; x!=256; x++)     /* Clear Sprites */
		vectorlist[x]=0;

	address=0;
	zoom=1.0;

	init_mouse();
	install_vga();
	draw_box();
	plot();
	labels();

 paint=17;
 event=0;
 mShow();

 while(event!=1)
 {
	rodent=mPos();
	x=rodent->column;
	y=rodent->row;
	b=rodent->buttonStatus;
	if (kbhit())
		{
		key=getch();
		if (key==0)
			{
			key=getch();
			if (key==68)	/* f10 = clear current character */
			/*	erase(sprite);   */
			if (key==59)	/* f1 = disk directory */
			/*	dir();  */
			if (key==65)	/* f7 = Quit */
				{
			/*	change_color(paint);  */
				}
			if (key==66)	/* f8 = Erase Set */
				{
				}
			if (key==67)	/* f9 = load colors */
				exit(1);
			if (key==72)	/* up arrow = up one row */
				{
				address++;
                if (address>(VRAM-8))
                    address=(VRAM-8);
				setfillstyle(1,0);
				bar(0,0,460,460);
				draw_box();
				plot();
				}
			if (key==80)	/* down arrow = down one row */
				{
				address--;
				if (address<0)
					address=0;
				setfillstyle(1,0);
				bar(0,0,460,460);
				draw_box();
				plot();
				}
			if (key==77)	/* right arrow = right one row */
				{
				address+=4;
				if (address<0)
					address=0;
				setfillstyle(1,0);
				bar(0,0,460,460);
				draw_box();
				plot();
				}
			if (key==75)	/* left arrow = left one row */
				{
				address-=4;
				if (address<0)
					address=0;
				setfillstyle(1,0);
				bar(0,0,460,460);
				draw_box();
				plot();
				}
			if (key==60)	/* f2 = save font */
				{getch();}
			if (key==59)	/* f1 now... */
				load_shape();
			if (key==62)   /* f4 = copy tile */
				{
				skip();
				}
			if (key==61)   /* f3 = copy tile */
				{
				skip_back();
				}
			if (key==64)   /* f6 = paste tile */
				{
				zoom+=.05;
				if (zoom>1)
					zoom=1;
				setfillstyle(1,0);
				bar(0,0,460,460);
				draw_box();
				plot();
				}
			if (key==63)   /* f5 = write ASCII table */
				{
				zoom-=.05;
				if (zoom<0)
					zoom=0.05;
				setfillstyle(1,0);
				bar(0,0,460,460);
				draw_box();
				plot();
				}

			}
		if (key>=48 && key<58)		/* Numbers 0-9 */
			sprite=key-48+26;
		if (key>=97 && key<123)		/* Letters a-z */
			sprite=key-96;
		if (key==46)					/* . */
			skip();
		if (key==64)					/* @ for (c) symbol */
			sprite=37;

/*		redraw(sprite);  */
		}
	if (b==1)		/* Button 1 (left) = plot a square */
		{
		setcolor(1);

	setfillstyle(1,0);
	bar(499,15,639,25);


/*		strcpy(message," ");
		itoa(x,r_string,10);
		itoa(y,g_string,10);
		strcat(message," x= ");
		strcat(message,r_string);
		strcat(message," y= ");
		strcat(message,g_string);
*/
		sprintf(message,"x=%3d y=%3d",x,y);
		outtextxy(500,16,message);
		}

	if (b==2)		/* Button 2 (right) */
		{
/*		plot();
*/		debounce();
	if (x>270 && y<179)     /* In menu area */
		{
		if ((y/12)==0)
				{
				restorecrtmode();
				exit(1);
				}
		else if ((y/12)==1)
				{
				 setfillstyle(1,30);
				 mHide();
				 bar(267,15,309,16+7);
				 setcolor(1);
				 outtextxy(269,16,"Load ");
				 delay(250);
				 setfillstyle(1,0);
				 bar(267,15,309,16+7);
				 setcolor(1);
				 outtextxy(269,16,"Load ");
				 delay(250);

				  setfillstyle(1,30);

				 bar(267,15,309,16+7);
				 setcolor(1);
				 outtextxy(269,16,"Load ");
				 delay(250);
				 setfillstyle(1,0);
				 bar(267,15,309,16+7);
				 setcolor(1);
				 outtextxy(269,16,"Load ");
				 delay(250);
				 mShow();
				 sprite=0; 				}
			else if ((y/12)==2)
				save_font();
			else if ((y/12)==3)
				delay(250);
		}  /* b1 */
	}
 }

 closegraph();

}

int huge detect256(void)
 {
 return(2);
 }

void debounce()
{
 int leave=1;
 locRec *temp;
 while (leave!=0)
	{
	temp=mPos();
	leave=temp->buttonStatus;
	}
}

void directory()
{
	struct ffblk ffblk;
	int done,count=0;
	restorecrtmode();
	printf("Directory listing of *.*\n");
	done = findfirst("*.*",&ffblk,0);
	while (!done)
		{
		count ++;
		printf("%-15s",ffblk.ff_name);
		if (count==5)
			{count=0; printf("\n");}
		done = findnext(&ffblk);
		}
	printf("\n");
}

void install_vga()
{
/*	g_driver = installuserdriver("vga256",detect256);
*/
	g_driver=VGA;
	g_mode=2;

	initgraph(&g_driver,&g_mode,"");
   g_error = graphresult();

   if (g_error < 0)
   {
     printf("initgraph error: %s.\n",grapherrormsg(g_error));
     exit(1);
   }
}

void resume_graphics()
{
	initgraph(&g_driver,&g_mode,"");
}

void draw_box()
{
 int x,y;
 setcolor(1);
 rectangle(0,10,440,450);
 for (y=0; y<23; y++)
	for (x=0; x<23; x++)
		putpixel(x*20,(y*20)+10,1);
 setrgbpalette(1,0,20,0);
 setrgbpalette(2,0,30,0);
 setcolor(2);
 line(220,11,220,449);
 line(1,220+10,439,220+10);
}

void labels()
{
 sprintf(message,"F1= load file");
 outtextxy(500,200,message);
 sprintf(message,"F9= quit");
 outtextxy(500,216,message);
 sprintf(message,"up  = addr+1");
 outtextxy(500,232,message);
 sprintf(message,"down= addr+1");
 outtextxy(500,248,message);
 sprintf(message,"right=addr+4");
 outtextxy(500,264,message);
 sprintf(message,"left= addr-4");
 outtextxy(500,280,message);
 sprintf(message,"F3= back");
 outtextxy(500,296,message);
 sprintf(message,"F4= forward");
 outtextxy(500,312,message);
 sprintf(message,"F5= zoom out");
 outtextxy(500,328,message);
 sprintf(message,"F6= zoom in");
 outtextxy(500,344,message);
 setcolor(7);
 sprintf(message,"Sega Vector Viewer");
 outtextxy(470,400,message);
 sprintf(message,"Version 0.10");
 outtextxy(470,416,message);
 sprintf(message,"clay@supra.com");
 outtextxy(470,432,message);


}

void skip()
{
 int i, command;
 for(i=address;i<VRAM;i=i+4)
	{
	command=vectorlist[i];
	if (command>127)
		{
		address=i+4;
		i=VRAM+1;
		}
	}
	setfillstyle(1,0);
	bar(0,0,460,460);
	draw_box();
	plot();
}

void skip_back()
{
 int i, command;
 if (address>8)
	 for(i=address-8;i>0;i=i-4)
		{
		command=vectorlist[i];
		if (command>127)
			{
			address=i+4;
			i=-1;
			}
		}
	setfillstyle(1,0);
	bar(0,0,460,460);
	draw_box();
	plot();
}

void plot()
{
 int i,j;
 unsigned char command;
 int end,sum;
 unsigned char colors[64];
 int xpos,ypos;
 int distance, angle, quadrant;
 double pi=3.14159265359;
 double real_angle=0.0;
 double deltax, deltay;
 int count;

 end=0;

 for(i=0;i<64;i++)
	colors[i]=0;

 count=0;

 /* count unique colors */
 for(i=address;i<VRAM;i=i+4)
	{
	command=vectorlist[i];
/*	printf("vectorlist[%d]=%d\n",i,command);
*/	if ((command & 0x80)>0)
		i=VRAM+1;
	command=command & 0x7e;
	colors[command]=1;
	count++;
	}

	setfillstyle(1,0);
	bar(500,0,639,100);

 sprintf(message,"vectors= %d",count);
 outtextxy(500,48,message);
 sprintf(message,"zoom= %1.2f",zoom);
 outtextxy(500,80,message);

	sum=0;
 for(i=0;i<64;i++)
	{
	sum+=colors[i];
	}
	sprintf(message,"colors=%d",sum);
	outtextxy(500,32,message);

	sprintf(message,"addr=0x%.4x",address);
	outtextxy(500,64,message);

 xpos=0;
 ypos=0;
 moveto(220,220);

 for(i=address;i<VRAM;i=i+4)
	{
	distance=vectorlist[i+1];  /* distance */
	angle=vectorlist[i+2];
	quadrant=vectorlist[i+3];
	real_angle=(((2*pi)/1024)*(angle+(quadrant*256)));

	deltax=sin(real_angle)*distance*zoom;
	deltay=-1*cos(real_angle)*distance*zoom;

    if (deltax<-320)
        deltax=-320;
    if (deltay<-320)
        deltay=-320;
    if (deltax>320)
        deltax=320;
    if (deltay>320)
        deltay=320;

	setcolor(4);

	command=vectorlist[i];
	if ((command & 0x01)==0)
		{
		moverel((int)deltax,(int)deltay);
		}
	else
		{
		linerel((int)deltax,(int)deltay);
		}

	if ((command & 0x80)>0)
		i=VRAM+1;

	}

 mShow();
}

void save_font()
{
	FILE *fp;
	char name[20];
	int x,y,z;

/*	save_screen(); */
	directory();
	printf("Enter the filename to save (filename.fnt): ");
	scanf("%s",&name);

	fp=fopen(name,"wb");
	if (fp>0)
	{
	for (z=0; z!=CHARS; z++)
		{
		for (y=0; y!=8; y++)
			for (x=0; x!=8; x++)
				fputc(sprites[z][x][y],fp);
		}
	fclose(fp);
	printf("%s has been saved. Press any key.",name);
	getch();
	}
	else
	{
	printf("Problem saving file!  Is your disk ok?  Hit any key.\n");
	getch();
	}

	install_vga();
	mGraphCursor(hsx1,hsy1,_DS,(unsigned) cursor1);
/*	load_screen(); */

}


void load_shape()
{
	FILE *fp;
	char name[20];
	int i,x,y,z;

	directory();
	printf("\n\nEnter the filename to load (filename.fnt) (~[return] to exit): ");
	scanf("%s",&name);

	fp=fopen(name,"rb");
	i=0;
	if (fp<=0)
	{
	printf("No file loaded!  (Error opening file.)  Hit any key.\n");
	getch();
	}
	else
	{
	while(!feof(fp))
		{
		vectorlist[i]=fgetc(fp);
		i++;
		}
	fclose(fp);
	}

	install_vga();
	mGraphCursor(hsx1,hsy1,_DS,(unsigned) cursor1);
	draw_box();
	plot();/* should redraw */
	labels();
	address=0;
}

void init_mouse()
{
	z=mReset();       /* Detect Mouse */
	if (z->exists==-1)
		printf("Mouse Driver/Mouse present.\n%d button mouse. ",z->nButtons);
	else
		{
		printf("Mouse Driver/Mouse not detected. \n [Hit Any Key]");
		getch();
		exit(1);
		}
	mColRange(4,639);
	mRowRange(0,397);
	mGraphCursor(hsx1,hsy1,_DS,(unsigned) cursor1);

}
