/* Sega G-80 System Vector Graphic Editor   */
/* Date: 04-26-97                           */
/* Last update: 03-08-98                    */
/* update: 05-08-99                         */
/* Programmer: Clayton N. Cowgill           */
/* Requires: PC, VGA, 512K RAM, Microsoft   */
/*           Compatible Mouse, BGI drivers. */

/* rev 1.6
	05/08/99
	change version number displayed, change e-mail address

/* rev 1.5
	03/08/98
	change save code for conversion to windows
*/

/* rev 1.4
	02/28/98  cnc
	cleaned up comments.  Changed revision number
*/
/* rev 1.3
	10/22/97  cnc
	change export routine to multiply by two to make objects bigger
*/

/* Rev 1.2 */

#include <c:\tc\include\graphics.h>
#include <c:\tc\include\stdio.h>
#include <c:\tc\include\conio.h>
#include <c:\tc\include\process.h>
#include <c:\tc\include\dos.h>
#include <c:\tc\include\dir.h>
#include <c:\tc\include\alloc.h>
#include <c:\tc\include\math.h>
#include "c:\spredit\mousey.c"

#define VRAM  100
#define MAXX  78

   unsigned cursor1[32] = {
	0xfff7,0xffe3,0xffc1,0xff80,0xff01,0xfe03,0xfc07,0xf80f,
	0xf01f,0xe03f,0xc07f,0x80ff,0x1ff,0x3ff,0x7ff,0xfff,
	0x0,0x8,0x1c,0x2e,0x44,0x98,0x130,0x260,
	0x4c0,0x980,0x1300,0x2600,0x5c00,0x6800,0x7000,0x0};
   unsigned hsx1 = 1;
   unsigned hsy1 = 14;

   unsigned cursor[32] = {
	0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
	0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
	0x0,0x0,0x100,0x100,0x100,0x100,0x100,0x0,
	0x7c7c,0x0,0x100,0x100,0x100,0x100,0x100,0x0};
   unsigned hsx = 7;
   unsigned hsy = 8;

   unsigned char CLUT[16] = {
   0x00, 0x04, 0x10, 0x14, 0x40, 0x44, 0x50, 0x54,
   0x2a, 0x06, 0x18, 0x1e, 0x60, 0x66, 0x74, 0x7e};
   /* black, blue, green, cyan, red, magenta, dark gray, light blue, light green,
      light cyan, light red, light magenta, orange/brown, light gray, yellow, white */


	unsigned size;
	int g_driver, g_mode, g_error, currentmode;
	int sprite=0;
   resetRec *z;
   locRec *rodent;
	char	message[80];
	char	filename[80];
	int	vectorlist[MAXX][VRAM][3];
	int	scratchlist[VRAM][3];
	int	scratchlast;
	int	last_vector[MAXX];
   unsigned char transform[500];
	int	xloc, yloc;
	int	address;
	int	grid;
	float	zoom;
	int	color;
	int	current;
	int   rotation;
	int	hidden;
	int	all;

int huge detect256(void);
void debounce();
void directory();
void install_vga();
void resume_graphics();
void draw_box();
void plot();
void save_screen();
void load_shape();
void save_shapes();
void init_mouse();
void dir(void);
void labels();
void skip();
void skip_back();
void gotoaddr();
void redraw();
void show_vcount();
void clear_all();
void messages(int x,int y,int length);
void export();
void write_shape();
void copy();
void paste();
void origin();
void trans();

main()
{
	int event, x, y, b;
	int paint=1,key;
	int left=270,right=310,top=-8;
	int i,j,c; /* for character read and display routine */
	int new_tile=0;
	int quit_key;
	int oldx, oldy;
	int	pass_count=0;
	int	length=0;
	int temp_sprite;

   clear_all();

	address=0;
	zoom=1.0;
	grid=3;
	sprintf(filename,"No file loaded");

	init_mouse();
	install_vga();
	draw_box();

	xloc=0;
	yloc=0;
	oldx=0;
	oldy=0;
	for (y=0; y<MAXX; y++)
		last_vector[y]=1;
	color=1;
	current=0;
	show_vcount();
	hidden=0;
	all=0;

 event=0;

	mGraphCursor(hsx1,hsy1,_DS,(unsigned) cursor);
	mShow();

 while(event!=1)
 {
	rodent=mPos();
	x=rodent->column;
	y=rodent->row;
	b=rodent->buttonStatus;

				if ((x!=oldx) || (y!=oldy))
					{
					messages(x-218,-y+238,length);
					}
	oldx=x;
	oldy=y;

	if (kbhit())
		{
		key=getch();
/*		printf("key= %d %d",key,getch());
*/		if (key==0)
			{
			key=getch();
			if (key==68)	/* f10 = clear all sprites */
				{
            clear_all();
            redraw();
				}
			if (key==59)	/* f1 = disk directory */
				{
				}
			if (key==65)	/* f7 = erase last vector */
				{
				last_vector[current]--;
				if (last_vector[current]<1)
					last_vector[current]=1;
				redraw();
				}
			if (key==66)	/* f8 = delete current sprite*/
				{
				last_vector[current]=1;
				for (x=0; x!=VRAM; x++)     /* Clear Sprites */
					{
					vectorlist[current][x][0]=0;
					vectorlist[current][x][1]=0;
					vectorlist[current][x][2]=0;
					}
				vectorlist[current][0][0]=224;
				vectorlist[current][0][1]=224+8;
				vectorlist[current][0][2]=0;
				redraw();

				}
			if (key==67)	/* f9 = quit */
				exit(1);
			if (key==72)	/* up arrow = up one row */
				{
				}
			if (key==80)	/* down arrow = down one row */
				{
				}
			if (key==77)	/* right arrow = rotate test image right */
				{
				rotation+=10;
				plot();
				}
			if (key==75)	/* left arrow = rotate test image left */
				{
				rotation-=10;
				plot();
				}
			if (key==59)	/* f1 = load sprites */
				load_shape();
			if (key==60)	/* f2 = save sprites */
				{
				save_shapes();
				}
			if (key==61)   /* f3 = back sprite */
				{
				current--;
				if (current<0)
					current=0;
				redraw();
				}
			if (key==62)   /* f4 = forward sprite */
				{
				current++;
				if (current>(MAXX-1))
					current=MAXX-1;
				redraw();
				}
			if (key==64)   /* f6 = grid larger */
				{
				grid++;
				if (grid>4)
					grid=4;
				redraw();
				}
			if (key==63)   /* f5 = grid smaller */
				{
				grid--;
				if (grid<1)
					grid=1;
				redraw();
				}
			if (key==83)	/* delete = delete last vector */
				{
				last_vector[current]--;
				if (last_vector[current]<0)
					last_vector[current]=0;
				redraw();
				}

			}
			if (key==32)	/* space = test sprite */
         	{
            /* F11 */
            export();
            }
			if (key==101)  /* e = write binary */
         	{
            /* F12 */
            write_shape();
            }
			if (key==99)	/* 'c' = copy sprite */
				{
				copy();
				}
			if (key==112) 	/* 'p' = paste sprite */
				{
				paste();
				redraw();
				}
			if (key==111) 	/* 'o' = set drawing origin */
				{
				origin();
				redraw();
				}
			if (key==104)	/* 'h' = hide/unhide vectices */
				{
				if (hidden==0)
					hidden=1;
				else
					hidden=0;
				redraw();
				}
			if (key==97)	/* 'a' = show all moves */
				{
				if (all==0)
					all=1;
				else
					all=0;
				redraw();
				}

		if (key>=48 && key<58)		/* Numbers 0-9 */
			sprite=key-48+26;
		if (key>=97 && key<123)		/* Letters a-z */
			sprite=key-96;
		if (key==46)					/* . = clear data, leave image */
			{
				last_vector[current]=1;
				for (x=0; x!=VRAM; x++)     /* Clear Sprites */
					{
					vectorlist[current][x][0]=0;
					vectorlist[current][x][1]=0;
					vectorlist[current][x][2]=0;
					}
				vectorlist[current][0][0]=224;
				vectorlist[current][0][1]=224+8;
				vectorlist[current][0][2]=0;
         }
		if (key==64)					/* transform current image by rotation */
			{
			temp_sprite=current;
			current=0;
			copy();
			current=temp_sprite;
			current++;
			if (current>(MAXX-1))
				current=MAXX-1;
			paste();
			export();
			trans();
			redraw();
			}

		} /* keybd hit */

	if (b==1)		/* Button 1 (left) = plot a square */
			{
			if (x<450)
			{
			mHide();
			while(b==1)
				{
				rodent=mPos();
				x=(((rodent->column)>>grid)<<grid)+8;
				y=(((rodent->row)>>grid)<<grid);
				b=rodent->buttonStatus;

				if ((x!=oldx) || (y!=oldy))
					{
					messages(x-218,-y+238,length);
					}
				i=vectorlist[current][last_vector[current]-1][0];
				j=vectorlist[current][last_vector[current]-1][1];
				length=(int)(sqrt( (((abs(i)-abs(x))/4)*((abs(i)-abs(x))/4)) + (((abs(j)-abs(y))/4)*((abs(j)-abs(y))/4)) )*4);
/*				setviewport(1,0,440,450,1);
*/

			if (length>254)
				{
				setcolor(4);
				outtextxy(500,96,"TOO LONG!");
				}
			else
				{
				setcolor(color);
				setfillstyle(1,0);
				bar(500,96,639,112);
				}

				moveto(vectorlist[current][last_vector[current]-1][0],vectorlist[current][last_vector[current]-1][1]);
				setwritemode(XOR_PUT);
				lineto(x,y);
				delay(30);
				moveto(vectorlist[current][last_vector[current]-1][0],vectorlist[current][last_vector[current]-1][1]);
				lineto(x,y);
				}
			oldx=x;
			oldy=y;
			setwritemode(COPY_PUT);
			moveto(vectorlist[current][last_vector[current]-1][0],vectorlist[current][last_vector[current]-1][1]);
			lineto(x,y);
			vectorlist[current][last_vector[current]][0]=x;
			vectorlist[current][last_vector[current]][1]=y;
			vectorlist[current][last_vector[current]][2]=color;
			last_vector[current]++;
			show_vcount();

			mShow();
			}
		else
			{
			mHide();
			color=getpixel(x,y);
			mShow();
			setfillstyle(1,0);
			bar(500,80,639,88);
			setcolor(color);
			sprintf(message,"color= %d",color);
			outtextxy(500,80,message);
			}
		}

	if (b==2)		/* Button 2 (right) */
		{
		if (x<450)
		{
		mHide();
		while(b==2)
			{
			rodent=mPos();
			x=(((rodent->column)>>grid)<<grid)+8;
			y=(((rodent->row)>>grid)<<grid);
			b=rodent->buttonStatus;

				if ((x!=oldx) || (y!=oldy))
					{
					messages(x-218,-y+238,length);
					}
			i=vectorlist[current][last_vector[current]-1][0];
			j=vectorlist[current][last_vector[current]-1][1];
			length=(int)(sqrt( (((abs(i)-abs(x))/4)*((abs(i)-abs(x))/4)) + (((abs(j)-abs(y))/4)*((abs(j)-abs(y))/4)) )*4);

			if (length>254)
				{
				setcolor(4);
				outtextxy(500,96,"TOO LONG!");
				}
			else
				{
				setcolor(15);
				setfillstyle(1,0);
				bar(500,96,639,112);
				}
			moveto(vectorlist[current][last_vector[current]-1][0],vectorlist[current][last_vector[current]-1][1]);
		setwritemode(XOR_PUT);
			lineto(x,y);
			delay(30);
			moveto(vectorlist[current][last_vector[current]-1][0],vectorlist[current][last_vector[current]-1][1]);
			lineto(x,y);
			}
			oldx=x;
			oldy=y;
			setwritemode(COPY_PUT);
			vectorlist[current][last_vector[current]][0]=x;
			vectorlist[current][last_vector[current]][1]=y;
			vectorlist[current][last_vector[current]][2]=0;
			last_vector[current]++;
			i=vectorlist[current][last_vector[current]-1][0];
			j=vectorlist[current][last_vector[current]-1][1];
			moveto(i,j);
			lineto(i-2,j-2);
			lineto(i+2,j+2);
			lineto(i,j);
			lineto(i-2,j+2);
			lineto(i+2,j-2);
			show_vcount();
			mShow();
		}  /* b2 */
		} /* if x<450 */
 }

 closegraph();

}

int huge detect256(void)
 {
 return(4);
 }

void origin()
{
	int	x,y,b;
	int	oldx,oldy;
	int 	length,i,j;
	int 	originx, originy;
	int	deltax,deltay;

	mHide();
/*	mGraphCursor(hsx1,hsy1,_DS,(unsigned) cursor);
	mShow();
*/
	rodent=mPos();
	x=rodent->column;
	y=rodent->row;
	originx=224; /* vectorlist[current][0][0]; */
	originy=232; /* vectorlist[current][1][0]; */

	if (x<450)
		{
/*		mHide();
*/		while(b!=1)
			{
			rodent=mPos();
			x=(((rodent->column)>>grid)<<grid);
			y=(((rodent->row)>>grid)<<grid);
			b=rodent->buttonStatus;
			if ((x!=oldx) || (y!=oldy))
				{
				messages(x-224,232-y,0);
				}
			setwritemode(XOR_PUT);
			moveto(1,y);
			lineto(450,y);
			delay(30);
			moveto(x,1);
			lineto(x,450);

			moveto(1,y);
			lineto(450,y);
			delay(30);
			moveto(x,1);
			lineto(x,450);


			oldx=x;
			oldy=y;
/*			mShow();
*/		}  /* b1 */
		debounce();
		deltax=originx-x;
		deltay=originy-y;
		for (i=0; i<last_vector[current];i++)
			{
			vectorlist[current][i][0]+=deltax;
			vectorlist[current][i][1]+=deltay;
			}
		setwritemode(COPY_PUT);
	mShow();
	} /* if x<450 */
}

void messages(int x,int y,int length)
{
	setcolor(1);
	setfillstyle(1,0);
	bar(500,0,639,56);
	sprintf(message,"x=%3d y=%3d",x,y);
	outtextxy(500,16,message);
	sprintf(message,"length=%d",length);
	outtextxy(500,32,message);
	sprintf(message,"sprite=%d",current);
	outtextxy(500,48,message);
}

void debounce()
{
 int leave=1;
 locRec *temp;
 while (leave!=0)
	{
	temp=mPos();
	leave=temp->buttonStatus;
	}
}

void directory()
{
	struct ffblk ffblk;
	int done,count=0;
	printf("Directory listing of *.*\n");
	done = findfirst("*.*",&ffblk,0);
	while (!done)
		{
		count ++;
		printf("%-15s",ffblk.ff_name);
		if (count==5)
			{count=0; printf("\n");}
		done = findnext(&ffblk);
		}
	printf("\n");

	printf("Current File: %s",filename);
}

void gotoaddr()
{
	int input=0;
	int number=0;
	printf("Enter Address to goto (0x prefix for hex):\n");
	scanf("%d",&input);
	if ((input>=0) && (input<(VRAM-8)))
		address=input;
	setfillstyle(1,0);
	bar(0,0,639,479);
	draw_box();
	plot(); /* should redraw */

}

void install_vga()
{
/*
	256 color drive, but 320x200 only...

	g_driver = installuserdriver("ibm8514",detect256);
	g_driver=DETECT;
*/

	g_driver=VGA;
	g_mode=2;


	initgraph(&g_driver,&g_mode,"");
   g_error = graphresult();

   if (g_error < 0)
   {
     printf("initgraph error: %s.\n",grapherrormsg(g_error));
     exit(1);
   }
}

void show_vcount()
{
	setfillstyle(1,0);
	bar(500,64,639,72);
	setcolor(5);

	sprintf(message,"vectors= %d",last_vector[current]);
	outtextxy(500,64,message);
	sprintf(message,"sprite=%d",current);
	outtextxy(500,48,message);

	setfillstyle(1,0);
	bar(500,80,639,88);
	setcolor(color);
	sprintf(message,"color= %d",color);
	outtextxy(500,80,message);

}

void resume_graphics()
{
	initgraph(&g_driver,&g_mode,"");
}

void draw_box()
{
 int x,y;
	mHide();
	setfillstyle(1,0);
	bar(0,0,639,479);


 setcolor(8);
 rectangle(0,8,448,456);
 for (y=0; y<(456/(pow(2,grid))); y++)
	for (x=0; x<(448/(pow(2,grid))); x++)
		putpixel(x*(pow(2,grid)),(y*pow(2,grid)),8);
/* setrgbpalette(1,0,20,0);
 setrgbpalette(2,0,30,0);
 setrgbpalette(8,64,64,0);
*/
 setcolor(8);
 line(1,224+8,448,224+8);
 line(224,8,224,456);
 labels();
 for (y=1;y<16;y++)
	{
	setfillstyle(1,y);
	bar(470,y*20,490,y*20+20);
	}

  mShow();
}

void labels()
{
 setcolor(7);
 sprintf(message,"a= all moves");
 outtextxy(500,120,message);
 sprintf(message,"h= un/hide moves");
 outtextxy(500,136,message);
 sprintf(message,"o= set origin");
 outtextxy(500,152,message);
 sprintf(message,"c= copy");
 outtextxy(500,168,message);
 sprintf(message,"p= paste");
 outtextxy(500,184,message);
 sprintf(message,"F1= load file");
 outtextxy(500,200,message);
 sprintf(message,"F2= save file");
 outtextxy(500,216,message);
 sprintf(message,"F3= sprite -");
 outtextxy(500,232,message);
 sprintf(message,"F4= sprite +");
 outtextxy(500,248,message);
 sprintf(message,"F5= grid -");
 outtextxy(500,264,message);
 sprintf(message,"F6= grid +");
 outtextxy(500,280,message);
 sprintf(message,"F7= erase");
 outtextxy(500,296,message);
 sprintf(message,"F8= delete");
 outtextxy(500,312,message);
 sprintf(message,"F9= quit");
 outtextxy(500,328,message);
 sprintf(message,"F10= erase ALL");
 outtextxy(500,344,message);
 sprintf(message,"SPC= test G-80");
 outtextxy(500,360,message);
 sprintf(message,"e= export G-80");
 outtextxy(500,376,message);

 outtextxy(10,470,filename);

 setcolor(4);
 sprintf(message,"Sega Vector Editor");
 outtextxy(470,420,message);
 sprintf(message,"Version 1.7");
 outtextxy(470,436,message);
 sprintf(message,"clay@yahoo.com");
 outtextxy(470,452,message);


}

void skip()
{
 int i, j, command;
 for(i=address;i<VRAM;i=i+1)
	{
	command=vectorlist[current][i];
	if (command>127)
		{
		if ((vectorlist[current][i+3])<4)
				{
				address=i+4;
				i=VRAM+1;
				}
		}
	}
	draw_box();
	plot();
}

void skip_back()
{
 int i, command;
 if (address>8)
	 for(i=address-8;i>0;i=i-1)
	{
	command=vectorlist[current][i];
	if (command>127)
		{
		if ((vectorlist[current][i+3])<4)
				{
				address=i+4;
				i=-1;
				}
		}
	}
	draw_box();
	plot();
}

void copy()
{
 int i;
 for(i=0;i<last_vector[current];i++)
	{
	scratchlist[i][0]=vectorlist[current][i][0];
	scratchlist[i][1]=vectorlist[current][i][1];
	scratchlist[i][2]=vectorlist[current][i][2];
	}
 scratchlast=last_vector[current];
}

void paste()
{
 int i;
 for(i=0;i<scratchlast;i++)
	{
	vectorlist[current][i][0]=scratchlist[i][0];
	vectorlist[current][i][1]=scratchlist[i][1];
	vectorlist[current][i][2]=scratchlist[i][2];
		}
 last_vector[current]=scratchlast;
}

void plot()
{
 int i,j;
 unsigned char command;
 int end,sum;
 unsigned char colors[64];
 int xpos,ypos;
 int distance, angle, quadrant;
 double pi=3.14;  /*159265359;*/
 double real_angle=0.0;
 double deltax, deltay;
 int count;
 int r,g,b;

 end=0;
 count=0;

 xpos=0;
 ypos=0;
 moveto(vectorlist[current][0][0], vectorlist[current][0][1]);

for(i=0;i<last_vector[current];i++)
	{
	distance=transform[i*4+1];  /* distance */
	angle=transform[i*4+2]+rotation;
	quadrant=transform[i*4+3];
	if (quadrant<4)
		{
		real_angle=(((2*pi)/1024)*(angle+(quadrant*256)));

		deltax=sin(real_angle)*distance*zoom;
		deltay=-1*cos(real_angle)*distance*zoom;

/*		printf("deltax= %i, deltay= %i\n", (int)deltax, (int)deltay);
		getch();
*/
		command=transform[i*4];

	setcolor(5);
		if ((command & 0x01)==0)
			{
			moverel((int)deltax,(int)deltay);
			}
		else
			{
			linerel((int)deltax,(int)deltay);
			}

		if ((command & 0x80)>0)
			i=501;
		}
	}
}

void trans()
{
 int i,j;
 unsigned char command;
 int end,sum;
 unsigned char colors[64];
 int xpos,ypos;
 int distance, angle, quadrant;
 double pi=3.14159265359;
 double real_angle=0.0;
 double deltax, deltay;
 int count;
 int r,g,b;
 int last_x, last_y, vector_cnt=0;

 end=0;
 count=0;

 xpos=0;
 ypos=0;
 moveto(vectorlist[current][0][0], vectorlist[current][0][1]);
/*  printf("x= %i", vectorlist[current][0][0]);
 printf("y= %i\n", vectorlist[current][0][1]);
 getch();
 */

 /* 224, 232 */

 last_x=224;
 last_y=232;

for(i=0;i<last_vector[current]+1;i++)
	{
	distance=transform[i*4+1];  /* distance */
	angle=transform[i*4+2]+rotation;
	quadrant=transform[i*4+3];
	if (quadrant<4)
		{
		real_angle=(((2*pi)/1024)*(angle+(quadrant*256)));

		deltax=sin(real_angle)*distance*zoom;
		deltay=-1*cos(real_angle)*distance*zoom;

		vectorlist[current][i][0]=last_x;
		vectorlist[current][i][1]=last_y;

/*		printf("deltax= %i, deltay= %i\n", (int)deltax, (int)deltay);
		getch();
*/
		last_x+=(int)deltax;
		last_y+=(int)deltay;

		command=transform[i*4];

	setcolor(5);
		if ((command & 0x01)==0)
			{
			moverel((int)deltax,(int)deltay);
			}
		else
			{
			lineto(last_x,last_y);
			}


/*		if ((command & 0x80)>0)
			i=501;
*/
		}
	}
}

void redraw()
{
int i,j;
int x,y;
draw_box();
show_vcount();

setcolor(0);
moveto(vectorlist[current][0][0],vectorlist[current][0][1]);

for (i=0;i<last_vector[current];i++)
	{
	j=vectorlist[current][i][2];
   if (j>0)
		{
      setcolor(j);
		lineto(vectorlist[current][i][0],vectorlist[current][i][1]);
   	}
	else
		{
			setcolor(15);
			x=vectorlist[current][i][0];
			y=vectorlist[current][i][1];
			if (hidden!=0)
				{
				if (all!=0)
					{
					setcolor(14);
					lineto(x,y);
					}
				else
					moveto(x,y);
				setcolor(15);
				lineto(x-2,y-2);
				lineto(x+2,y+2);
				lineto(x,y);
				lineto(x-2,y+2);
				lineto(x+2,y-2);
				}
			moveto(x,y);
		}

	}

}

void save_shapes()
{
	FILE *fp;
	char name[20];
	int x,y,z;
	int	result;

	directory();
	printf("\nEnter the filename to save (filename.g80): ");
	scanf("%s",&name);

	fp=fopen(name,"wb");
	if (fp>0)
	{
	for (y=0; y<MAXX; y++)
		{
		fprintf(fp,"%d\r\n",last_vector[y]);
/*		printf("last_vector[%d]=%d\n",y,last_vector[y]);
		getch();
*/		for (x=0; x<last_vector[y]; x++)
			for (z=0; z<3; z++)
				{
				fprintf(fp,"%d\r\n",vectorlist[y][x][z]);
/*				printf("vectorlist[%d][%d][%d]=%d\n",y,x,z,vectorlist[y][x][z]);
				getch();
*/				}
		}
	result=fclose(fp);
	if (result==0)
		{
		printf("%s has been saved. Press any key.",name);
		getch();
		}
	else
		{
		printf("%s was NOT saved without errors! Press any key.",name);
		getch();
		}
	}
	else
	{
	printf("Problem saving file!  Is your disk ok?  Hit any key.\n");
	getch();
	}
	redraw();
}


void load_shape()
{
	FILE *fp;
	char name[20];
	int i,x,y,z;

	directory();
	printf("\n\nEnter the filename to load (filename.fnt) (~[return] to exit): ");
	scanf("%s",&name);

	fp=fopen(name,"rb");
	i=0;
	if (fp<=0)
	{
	printf("No file loaded!  (Error opening file.)  Hit any key.\n");
	getch();
	}
	else
	{
	for (y=0; y<MAXX; y++)
		{
		fscanf(fp,"%d\n",&last_vector[y]);
		for (x=0; x<last_vector[y]; x++)
			for (z=0; z<3; z++)
				fscanf(fp,"%d\n",&vectorlist[y][x][z]);
		}
	fclose(fp);
	sprintf(filename,"File: %s",name);
	}

	redraw();
	address=0;
}

void init_mouse()
{
	z=mReset();       /* Detect Mouse */
	if (z->exists==-1)
		printf("Mouse Driver/Mouse present.\n%d button mouse. ",z->nButtons);
	else
		{
		printf("Mouse Driver/Mouse not detected. \n [Hit Any Key]");
		getch();
		exit(1);
		}
	mColRange(4,639);
	mRowRange(0,397);
	mGraphCursor(hsx1,hsy1,_DS,(unsigned) cursor);

}

void export()
{
int loop;
int i,j,x,y;
double opp, adj;
double angle;
double length;
unsigned char	ang, quad;
unsigned char	color, len;
double pi=3.14159265359;
int counter=0;

	for (loop=1;loop<=last_vector[current]-1;loop++)
   	{
		i=1.0*(vectorlist[current][loop][0]);
		j=1.0*(vectorlist[current][loop][1]);
		x=1.0*(vectorlist[current][loop-1][0]);
		y=1.0*(vectorlist[current][loop-1][1]);
      adj=-(abs(i)-abs(x));
      opp=-(abs(j)-abs(y));
      if ((opp==0)&&(adj==0))
      	angle=0;
      else
      	angle=atan2(opp,adj);
      length=sqrt(((opp*opp))+((adj*adj)));
      angle=(((angle)+(pi*3/2))/(2*pi))*1024;
      ang=(char)(((int)(angle))&0x00ff);
      quad=(char)((((int)(angle))&0x0300)>>8);
      len=(char)(length)+1;

      color=0;
      color=color|(CLUT[vectorlist[current][loop][2]]);
      if (color!=0)
      	color=color|0x01; /* draw line */
      if (loop==(last_vector[current]-1))
      	color=color|0x80; /* last line */

/*      printf("\ni= %d, j=%d, x=%d, y= %d, angle= %lf, length= %lf\n",i,j,x,y,angle,length);
      printf("angle= %d, quad= %d\n",ang,quad);
      getch();
*/
      transform[counter++]=color;
      transform[counter++]=len;
      transform[counter++]=ang;
      transform[counter++]=quad;

      }
      redraw();
      plot();
}

void write_shape()
{
	FILE *fp;
	char name[20];
	int z;
	int	result;
int loop;
int i,j,x,y;
double opp, adj;
double angle;
double length;
unsigned char	ang, quad, len;
unsigned char	color;
double pi=3.14159265359;


	directory();
	printf("\nEnter the filename to write (filename.bin): ");
	scanf("%s",&name);

	fp=fopen(name,"wb");
	if (fp>0)
	{
	for (loop=1;loop<=last_vector[current]-1;loop++)
   	{
      i=vectorlist[current][loop][0];
      j=vectorlist[current][loop][1];
      x=vectorlist[current][loop-1][0];
      y=vectorlist[current][loop-1][1];
      adj=-(abs(i)-abs(x));
      opp=-(abs(j)-abs(y));
      if ((opp==0)&&(adj==0))
      	angle=0;
      else
      	angle=atan2(opp,adj);
      length=sqrt(((opp*opp))+((adj*adj)));
      angle=(((angle)+(pi*3/2))/(2*pi))*1024;
      ang=(char)(((int)(angle))&0x00ff);
      quad=(char)((((int)(angle))&0x0300)>>8);
      len=(char)(length)+1;

      color=0;
      color=color|(CLUT[vectorlist[current][loop][2]]);
      if (color!=0)
      	color=color|0x01; /* draw line */
      if (loop==(last_vector[current]-1))
      	color=color|0x80; /* last line */

      fputc(color,fp);
      fputc(len,fp);
      fputc(ang,fp);
      fputc(quad,fp);

      }

	result=fclose(fp);
	if (result==0)
		{
		printf("%s has been saved. Press any key.",name);
		getch();
		}
	else
		{
		printf("%s was NOT saved without errors! Press any key.",name);
		getch();
		}
	}
	else
	{
	printf("Problem saving file!  Is your disk ok?  Hit any key.\n");
	getch();
	}
	redraw();
}


void clear_all()
{
	int x,y;
	for (y=0; y<MAXX; y++)
		for (x=0; x!=VRAM; x++)     /* Clear Sprites */
			{
			vectorlist[y][x][0]=0;
			vectorlist[y][x][1]=0;
			vectorlist[y][x][2]=0;
			}

	for (y=0; y<MAXX; y++)
		{
		vectorlist[y][0][0]=224;
		vectorlist[y][0][1]=224+8;
		vectorlist[y][0][2]=0;
	   last_vector[y]=1;
      }
}
